
#include <iostream>
#include "ContextFreeGrammar.h"
#include "LL1ParserGenerator.h"
#include "LR0ParserGenerator.h"
using namespace std;
using namespace ContextFreeGrammars;


bool VERBOSE = true;


typedef std::string token;
int main(int argc, char** argv)
{
    try
    {

        ContextFreeGrammar<token> cfg;
        cfg.LoadFromStream(cin);

        LR0ParserGenerator<token> parsergen(cfg);
        LRParser<token>* parser = parsergen.Generate();
        if(parser != NULL)
        {
            if(argc > 1)
            {
                stringstream s;
                s << argv[1];
                Tokenizer<token,1> tokenizer(s);

                parser->Parse(tokenizer, cout);
            }
            delete parser;
        }

        /*
        LL1ParserGenerator<token> parsergen(cfg);
        if(parsergen.IsLL1Grammar())
        {
            LL1Parser<token>* parser = parsergen.Generate();
            parser->verbose = VERBOSE;

            if(argc > 1)
            {
                stringstream s;
                s << argv[1];
                Tokenizer<token,1> tokenizer(s);
                void* result = parser->Parse(tokenizer, cout);
            }
            else
            {
                parser->GenerateCPlusPlusSourceCode(cout);
            }

            delete parser;
        }
        else
        {
            cerr << "This is not an LL(1) Grammar. Cannot proceed." << endl;
        }
        */




    }
    catch(const char* msg)
    {
        cerr << "Exception caught: " << msg << std::endl;
    }

    return 0;
}